///////////////////////////////////////////////////////////////////////////////
//
// This software module was originally developed by
//
// Dummy author
// Dummy company
//
// in the course of development of the MPEG-7 Experimentation Model.
//
// This software module is an implementation of a part of one or more MPEG-7
// Experimentation Model tools as specified by the MPEG-7 Requirements.
//
// ISO/IEC gives users of MPEG-7 free license to this software module or
// modifications thereof for use in hardware or software products claiming
// conformance to MPEG-7.
//
// Those intending to use this software module in hardware or software products
// are advised that its use may infringe existing patents. The original
// developer of this software module and his/her company, the subsequent
// editors and their companies, and ISO/IEC have no liability for use of this
// software module or modifications thereof in an implementation.
//
// Copyright is not released for non MPEG-7 conforming products. The
// organizations named above retain full right to use the code for their own
// purpose, assign or donate the code to a third party and inhibit third
// parties from using the code for non MPEG-7 conforming products.
//
// Copyright (c) 1998-1999.
//
// This notice must be included in all copies or derivative works.
//
// Applicable File Name:  DummyType.cpp
//

#include <stdio.h>
#include "Descriptors.h"

using namespace XM;

const UUID DummyTypeDescriptorInterface::myID = UUID("");
const char *DummyTypeDescriptorInterface::myName = 
"DummyTypeDescriptionInterface";

const UUID DummyTypeDescriptor::myID = UUID("");
const char *DummyTypeDescriptor::myName = "DummyTypeDescriptor";

const UUID DummyTypeDescriptor::valID = UUID("");
const char *DummyTypeDescriptor::valName = "";

const UUID DummyTypeDescriptorInterfaceABC::myID = UUID();

DummyTypeDescriptorInterfaceABC::DummyTypeDescriptorInterfaceABC()
{ SetInterfaceID(myID);}

//=============================================================================
DummyTypeDescriptorInterface::
DummyTypeDescriptorInterface(DummyTypeDescriptor *aDescriptor):
m_Descriptor(aDescriptor)
{
  SetInterfaceID(myID);
}

//----------------------------------------------------------------------------
DummyTypeDescriptorInterface::~DummyTypeDescriptorInterface()
{
}

//----------------------------------------------------------------------------
void DummyTypeDescriptorInterface::addref(void)
{ m_Descriptor->addref(); }

//----------------------------------------------------------------------------
void DummyTypeDescriptorInterface::release(void)
{ m_Descriptor->release(); }

//----------------------------------------------------------------------------
const UUID& DummyTypeDescriptorInterface::GetInterfaceID(void)
{ return myID; }

//----------------------------------------------------------------------------
const char *DummyTypeDescriptorInterface::GetName(void)
{ return myName; }

#ifdef __HasSubTypes /*include this section if sub descriptors exist,
		       remove this section if no sub-descriptors exist*/
//----------------------------------------------------------------------------
SubDummyTypeADescriptorInterfaceABC
*DummyTypeDescriptorInterface::GetSubDummyTypeADescriptorInterface(void)
{
  return m_Descriptor->GetSubDummyTypeADescriptorInterface();
}

//----------------------------------------------------------------------------
unsigned long DummyTypeDescriptorInterface::
SetSubDummyTypeADescriptorInterface(SubDummyTypeADescriptorInterfaceABC
				    *aSubDummyTypeADescriptorInterface)	
{
  return m_Descriptor->
    SetSubDummyTypeADescriptorInterface(aSubDummyTypeADescriptorInterface);
}

//----------------------------------------------------------------------------
SubDummyTypeBDescriptorInterfaceABC
*DummyTypeDescriptorInterface::GetSubDummyTypeBDescriptorInterface(void)
{
  return m_Descriptor->GetSubDummyTypeBDescriptorInterface();
}

//----------------------------------------------------------------------------
unsigned long DummyTypeDescriptorInterface::
SetSubDummyTypeBDescriptorInterface(SubDummyTypeBDescriptorInterfaceABC
				    *aSubDummyTypeBDescriptorInterface)	
{
  return m_Descriptor->
    SetSubDummyTypeBDescriptorInterface(aSubDummyTypeBDescriptorInterface);
}

#endif /* __HasSubTypes*/
//----------------------------------------------------------------------------
long DummyTypeDescriptorInterface::GetDummyContents(void)
{ return m_Descriptor->GetDummyContents(); }

//----------------------------------------------------------------------------
void DummyTypeDescriptorInterface::SetDummyContents(const long val)
{m_Descriptor->SetDummyContents(val); }

//----------------------------------------------------------------------------
unsigned long DummyTypeDescriptorInterface::
ExportDDL(GenericDSInterfaceABC *aParentDescription)
{ return m_Descriptor->ExportDDL(aParentDescription); }

//----------------------------------------------------------------------------
unsigned long DummyTypeDescriptorInterface::
ImportDDL(GenericDSInterfaceABC *aDescription)
{ return m_Descriptor->ImportDDL(aDescription); }

//=============================================================================
DummyTypeDescriptor::DummyTypeDescriptor():
m_refcount(0),
m_Interface(this),
m_isProprietary(false),
#ifdef __HasSubTypes /*include this section if sub descriptors exist,
		       remove this section if no sub-descriptors exist*/
m_SubDummyTypeADescriptorInterface(NULL),
m_SubDummyTypeBDescriptorInterface(NULL),
#endif /* __HasSubTypes*/
m_DummyContents(0)
{
  SetExposedInterface(&m_Interface);
}

#ifdef __HasSubTypes /*include this section if sub descriptors exist,
		       remove this section if no sub-descriptors exist*/
//----------------------------------------------------------------------------
DummyTypeDescriptor::
DummyTypeDescriptor(SubDummyTypeAIDescriptorInterfaceABC
		    *aSubDummyTypeAInterface,
		    SubDummyTypeBDescriptorInterfaceABC
		    *aSubDummyTypeBInterface):
m_refcount(0),
m_Interface(this),
m_isProprietary(false),
m_SubDummyTypeADescriptorInterface(NULL),
m_SubDummyTypeBDescriptorInterface(NULL),
m_DummyContents(0)
{
#ifdef VERBOSE
  fprintf(stderr,"Create sub descriptors\n");
#endif

  if (!aSubDummyTypeAInterface) {
    SubDummyTypeADescriptor *aSubDummyTypeA;
    aSubDummyTypeA= new SubDummyTypeADescriptor/* or (0,0..0) if subsub Descriptors*/;
    aSubDummyTypeAInterface=aSubDummyTypeA->GetInterface();
  }
  if (aSubDummyTypeAInterface)
    SetSubDummyTypeADescriptorInterface(aSubDummyTypeAInterface);

  if (!aSubDummyTypeBInterface) {
    SubDummyTypeBDescriptor *aSubDummyTypeB;
    aSubDummyTypeB= new SubDummyTypeBDescriptor/* or (0,0..0) if subsub Descriptors*/;
    aSubDummyTypeBInterface=aSubDummyTypeB->GetInterface();
  }
  if (aSubDummyTypeBInterface)
    SetSubDummyTypeBDescriptorInterface(aSubDummyTypeBInterface);
}

#endif /* __HasSubTypes*/
//----------------------------------------------------------------------------
DummyTypeDescriptor::~DummyTypeDescriptor()
{
#ifdef VERBOSE
  fprintf(stderr,"DummyType delete\n");
#endif
#ifdef __HasSubTypes /*include this section if sub descriptors exist,
		       remove this section if no sub-descriptors exist*/
  if (m_SubDummyTypeADescriptorInterface)
    m_SubDummyTypeADescriptorInterface->release();
  if (m_SubDummyTypeBDescriptorInterface)
    m_SubDummyTypeBDescriptorInterface->release();
#endif /* __HasSubTypes*/
}

//----------------------------------------------------------------------------
const UUID& DummyTypeDescriptor::GetObjectID(void)
{ return myID; }

//----------------------------------------------------------------------------
const char *DummyTypeDescriptor::GetName(void)
{ return myName; }

//----------------------------------------------------------------------------
const UUID& DummyTypeDescriptor::GetValueID(void)
{ return valID; }

//----------------------------------------------------------------------------
const char* DummyTypeDescriptor::GetValueName(void)
{ return valName; }

//----------------------------------------------------------------------------
bool DummyTypeDescriptor::IsProprietary(void)
{ return m_isProprietary; }

#ifdef __HasSubTypes /*include this section if sub descriptors exist,
		       remove this section if no sub-descriptors exist*/
//----------------------------------------------------------------------------
SubDummyTypeADescriptorInterfaceABC *DummyTypeDescriptor::
GetSubDummyTypeADescriptorInterface(void)
{
  return m_SubDummyTypeADescriptorInterface;
}

//----------------------------------------------------------------------------
unsigned long DummyTypeDescriptor::SetSubDummyTypeADescriptorInterface
        (SubDummyTypeADescriptorInterfaceABC *aSubDummyTypeA)	
{
  if (!aSubDummyTypeA) return (unsigned long) -1;
  if (m_SubDummyTypeADescriptorInterface == aSubDummyTypeA) return 0;
  if (m_SubDummyTypeADescriptorInterface)
    m_SubDummyTypeADescriptorInterface->release();
  m_SubDummyTypeADescriptorInterface = aSubDummyTypeA;
  if (m_SubDummyTypeADescriptorInterface)
    m_SubDummyTypeADescriptorInterface->addref();
  else return (unsigned long) -1;

  return 0;
}

//----------------------------------------------------------------------------
SubDummyTypeBDescriptorInterfaceABC *DummyTypeDescriptor::
GetSubDummyTypeBDescriptorInterface(void)
{
  return m_SubDummyTypeBDescriptorInterface;
}

//----------------------------------------------------------------------------
unsigned long DummyTypeDescriptor::SetSubDummyTypeBDescriptorInterface
        (SubDummyTypeBDescriptorInterfaceABC *aSubDummyTypeB)	
{
  if (!aSubDummyTypeB) return (unsigned long) -1;
  if (m_SubDummyTypeBDescriptorInterface == aSubDummyTypeB) return 0;
  if (m_SubDummyTypeBDescriptorInterface)
    m_SubDummyTypeBDescriptorInterface->release();
  m_SubDummyTypeBDescriptorInterface = aSubDummyTypeB;
  if (m_SubDummyTypeBDescriptorInterface)
    m_SubDummyTypeBDescriptorInterface->addref();
  else return (unsigned long) -1;

  return 0;
}

#endif /* __HasSubTypes*/
//----------------------------------------------------------------------------
long DummyTypeDescriptor::GetDummyContents(void)
{ return m_DummyContents; }

//----------------------------------------------------------------------------
void DummyTypeDescriptor::SetDummyContents(const long val)
{m_DummyContents=val; }

//----------------------------------------------------------------------------
unsigned long DummyTypeDescriptor::
ExportDDL(GenericDSInterfaceABC *aParentDescription)
{
  GenericDS l_DDLDescription;

  if (!aParentDescription) return (unsigned long) -1;

  l_DDLDescription=aParentDescription->CreateChild("Descriptor");
  l_DDLDescription.SetAttribute("xsi:type","DummyType");
  l_DDLDescription.SetAttribute("DummyContents",(int)m_DummyContents);

#ifdef __HasSubTypes /*include this section if sub descriptors exist,
		       remove this section if no sub-descriptors exist*/
  if (m_SubDummyTypeADescriptorInterface) {
    m_SubDummyTypeADescriptorInterface->
      ExportDDL(DummyTypeDDLDescription.GetInterface());
  }
  if (m_SubDummyTypeBDescriptorInterface) {
    m_SubDummyTypeBDescriptorInterface->
      ExportDDL(DDLDescription.GetInterface());
  }
#endif /* __HasSubTypes*/
  return 0;
}

//----------------------------------------------------------------------------
unsigned long DummyTypeDescriptor::
ImportDDL(GenericDSInterfaceABC *aDescription)
{
  int val;
  string xsitype;

  GenericDS l_DLLDescription;
  GenericDSInterfaceABC *l_DDLDescriptionInterface    = NULL;

  if (!aDescription) return (unsigned long) -1;

  /* if aDescriptor is of correct type*/
  if (aDescription->GetDSName() == "Descriptor") {
    aDescription->GetTextAttribute("xsi:type",xsitype);
    if (xsitype == "DummyType") {
      l_DDLDescriptionInterface=aDescription;
    }
  }

  /* else search for DummyType as a child*/
  if (!l_DDLDescriptionInterface) {
    l_DLLDescription=aDescription->GetDescription("Descriptor");
    
    /* search for correct xsi type*/
    while (!l_DLLDescription.isNull()) {
      l_DLLDescription.GetTextAttribute("xsi:type", xsitype);
      if(xsitype=="DummyType") break;
      l_DLLDescription=
	l_DLLDescription.GetNextSibling("Descriptor");
    }
      

    /* DummyType not found*/
    if (l_DLLDescription.isNull()) return (unsigned long)-1;
    /* DummyType found*/
    l_DDLDescriptionInterface=
      l_DLLDescription.GetInterface();
  }

  l_DDLDescriptionInterface->GetIntAttribute("DummyContents",val);
  SetDummyContents((long)val);


#ifdef __HasSubTypes /*include this section if sub descriptors exist,
		       remove this section if no sub-descriptors exist*/
  GenericDS SubDescription;
  if (m_SubDummyTypeADescriptorInterface) {
    SubDescription=l_DummyTypeDDLDescriptionInterface->
      GetDescription("SubDummyTypeA",0);
    if (!SubDescription.isNull()) {
      m_SubDummyTypeADescriptorInterface->
	ImportDDL(SubDescription.GetInterface());
    }
  }
  if (m_SubDummyTypeBDescriptorInterface) {
    SubDescription=l_DDLDescriptionInterface->
      GetDescription("SubDummyTypeB",0);
    if (!SubDescription.isNull()) {
      m_SubDummyTypeBDescriptorInterface->
	ImportDDL(SubDescription.GetInterface());
    }
  }
#endif /* __HasSubTypes*/
  return 0;
}

//----------------------------------------------------------------------------
void DummyTypeDescriptor::addref(void)

{
  m_refcount++;
}

//----------------------------------------------------------------------------
void DummyTypeDescriptor::release(void)

{
  if (!(--m_refcount)) delete this;
}


//----------------------------------------------------------------------------
DummyTypeDescriptorInterfaceABC *DummyTypeDescriptor::GetInterface(void)
{ return &m_Interface; }


